var autoHIDE =
{
  CI : Components.interfaces,

  pref   : Components.classes["@mozilla.org/preferences-service;1"]
           .getService(Components.interfaces.nsIPrefService)
           .getBranch("extensions.autohide."),

  winMed : Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService().QueryInterface(Components.interfaces.nsIWindowMediator),

  obs    : Components.classes["@mozilla.org/observer-service;1"]
           .getService(Components.interfaces.nsIObserverService),

  drag   : Components.classes["@mozilla.org/widget/dragservice;1"]
           .getService(Components.interfaces.nsIDragService),

  zombie : false,
  init   : false,

ahMouseObserver : {
  observe : function (subject, topic, data) {
    if (!autoHIDE.winUtil.isActiveWindow())
      return;

    if (topic == "ahMouseMove") {
      var mData = data.split("|");

      if (!autoHIDE.Show && autoHIDE.winUtil.isShiftDown && autoHIDE.zombie && autoHIDE.zombieMove) {
        window.moveTo(mData[0]-100, mData[1]-100)
        return
      }

      var evt = document.createEvent("MouseEvents");
      evt.initMouseEvent("mousemove", 1, 1, window, 0,
                         mData[0], mData[1], 0, 0, 0, 0, 0, 0, 0, window);

      autoHIDE.ShowBars(evt);
    }
  }
},

ah4711 : {
  WPL : Components.interfaces.nsIWebProgressListener,

  QueryInterface : function(ID) {
    if (ID.equals(this.WPL))
      return this;

    return Components.results.NS_NOINTERFACE;
  },

  onStateChange : function(a, b, ahF, c) {
    var ah = autoHIDE

    if (ah.Pref("statFloat") && !ah.Pref("bars.statBar.always") && !ah.ShowTB) {
      if (ahF & this.WPL.STATE_START)
        ah.sBar.setAttribute("ahHIDE", false);

      if (ahF & this.WPL.STATE_STOP)
        ah.sBar.setAttribute("ahHIDE", true);
    }
  },

  onLocationChange : function() {
    if (autoHIDE.Show)
      autoHIDE.MoveContent(true);
  },

  onProgressChange : function(){},
  onStatusChange : function(){},
  onSecurityChange : function(){},
  onLinkIconAvailable : function(){}
},

GetCMDLine : function() {
  if (this.init)
    return;

  var ah = this
  ah.init = true

  document.getElementById("contentAreaContextMenu")
          .addEventListener("popupshowing", function(e){autoHIDE.Context(e)}, true);

  ah.Nav = document.getElementById("navigator-toolbox")
  ah.Nav.addEventListener("popupshowing", function(e){autoHIDE.ObservePopups(e)}, true)

  addEventListener("unload", function() {
    autoHIDE.pref.setBoolPref("closedFull", fullScreen)
    autoHIDE.pref.setBoolPref("closedZombie", autoHIDE.zombie)
    try {
      autoHIDE.obs.removeObserver(autoHIDE.ahMouseObserver, "ahMouseMove")
    }
    catch (e) {}
    getBrowser().removeProgressListener(autoHIDE.ah4711)
  }, false);

  ah.Win = document.getElementById("main-window")
  ah.BC = document.getElementById("autoHIDE_BC")
  ah.Persist = ah.Win.getAttribute("persist")
  ah.Enum = ah.winMed.getEnumerator("navigator:browser")
  ah.Enum.getNext()

  if (!ah.Enum.hasMoreElements()) {
    ah.openFull = ah.Pref("closedFull")
    ah.openZombie = ah.Pref("closedZombie")
  }
  else if ("arguments" in window && ah.Pref("newFull")) {
    if (window.opener)
      ah.lastWin = window.opener;
    else {
      ah.Enum1 = ah.winMed.getZOrderDOMWindowEnumerator("navigator:browser", true)
      ah.Enum1.getNext()
      ah.lastWin = ah.Enum1.getNext()
    }
    if (ah.lastWin && ah.lastWin.fullScreen)
      ah.openFull = true;

    if (ah.lastWin && ah.lastWin.autoHIDE && ah.lastWin.autoHIDE.zombie)
      ah.openZombie = true;
  }

  var timeout = 500;

  if ("@krickelkrackel/ahWin32Utils;1" in Components.classes) {
    try {
      ah.winUtil = Components.classes["@krickelkrackel/ahWin32Utils;1"]
                   .createInstance(ah.CI.ahIWin32Utils);

      ah.baseWin = window.QueryInterface(ah.CI.nsIInterfaceRequestor)
                  .getInterface(ah.CI.nsIWebNavigation)
                  .QueryInterface(ah.CI.nsIBaseWindow);

      ah.winUtil.init(ah.baseWin);
      timeout = ah.winUtil.getTimeout;
    }
    catch (e) {
      ah.winUtil = false;
    }
  }

  if (ah.openFull || ah.openZombie)
    setTimeout("fullScreen=true", timeout);
},

Context : function(e) {
  if (e.target.id != "contentAreaContextMenu")
    return;

  var cMenu = document.getElementById("context-toggle-fullscreen")
  cMenu.hidden = cMenu.previousSibling.hidden = true

  if ((!document.getElementById("context-back").hasAttribute("hidden") ||
       !document.getElementById("context-viewimage").hasAttribute("hidden")) &&
       !this.Pref("noContext"))
    cMenu.hidden = cMenu.previousSibling.hidden = false;
},

ShowBars : function(e) {
  var ah = autoHIDE

  if (ah.Popup && ah.Popup.state && ah.Popup.state == "closed")
    ah.Popup = null;

  if (ah.Popup || ("gestureInProgress" in window && gestureInProgress))
    return;

  if (ah.mTimer)
    clearTimeout(ah.mTimer);

  if (!ah.Show && e.screenY <= ah.Win.boxObject.screenY + ah.senseArea) {
    if (!ah.drag.getCurrentSession())
      ah.mTimer = setTimeout("autoHIDE.HideToolbar()", ah.delay);
    else
      ah.HideToolbar();
  }

  var yCondition
  yCondition = getBrowser().mCurrentBrowser.boxObject.screenY + ah.delta + 50

  if (ah.Show && e.screenY > yCondition) {
    if (!ah.drag.getCurrentSession())
      ah.mTimer = setTimeout("autoHIDE.HideToolbar()", ah.hideDelay);
    else
      ah.HideToolbar();
  }

  if (ah.tbTimer)
    clearTimeout(ah.tbTimer);

  if (!ah.ShowTB && e.screenY > ah.sBar.boxObject.screenY - ah.senseArea -2)
    ah.tbTimer = setTimeout("autoHIDE.HideStatusBar()", ah.delay);

  if (ah.ShowTB && e.screenY < ah.sBar.boxObject.screenY -50)
    ah.tbTimer = setTimeout("autoHIDE.HideStatusBar()", ah.hideDelay);
},

HideStatusBar : function() {
  if (!fullScreen && !this.zombie)
    return;

  var ah = this

  if (ah.Pref("bars.statBar.always") || !ah.Pref("bars.statBar"))
    return;

  if (ah.ShowTB) {
    ah.sBar.setAttribute('ahHIDE', true)
    ah.ShowTB = false
    return
  }

  ah.sBar.setAttribute('ahHIDE', false)
  ah.ShowTB = true
},

HideToolbar : function() {
  if ((!fullScreen && !this.zombie) || this.delta < 5)
    return;

  var ah = this

  if (ah.Show) {
    if (ah.noFloat || !ah.winUtil) {
      ah.ResetMenu()
      return
    }

    ah.winUtil.setRedraw(false, false)
    ah.MoveContent(false)
    ah.ResetMenu()
    setTimeout(autoHIDE.winUtil.setRedraw, 0, true, false)
    return
  }

  if (ah.noFloat || !ah.winUtil) {
    ah.SetMenu()
    return
  }

  ah.winUtil.setRedraw(false, false)
  ah.SetMenu()

  try {
    BookmarksToolbar.resizeFunc(null)
  }
  catch (e) {}
  try {
    document.getElementById("bookmarksBarContent").updateChevron(null);
  }
  catch (e) {}

  ah.MoveContent(true)
  setTimeout(autoHIDE.winUtil.setRedraw, 0, true, false)
},

MoveContent : function(aMove) {
  var ah = autoHIDE

  if (!ah.noFloat && ah.winUtil) {
    if (aMove) {
      var cB = getBrowser().mCurrentBrowser;

      if (!cB.ahMargin) {
        if (!cB.style.marginTop)
         cB.ahOldTop = 0;
        else
          cB.ahOldTop = parseFloat(cB.style.marginTop);

        cB.style.marginTop = cB.ahOldTop - ah.delta  + "px"
        cB.ahMargin = true
      }
      return
    }

    var brs = getBrowser().browsers

    for (var b = 0; b < brs.length; b++) {
      if (brs[b].ahMargin) {
        brs[b].style.marginTop = brs[b].ahOldTop + "px"
        brs[b].ahMargin = null
      }
    }
  }
},

SetMenu : function(aBool) {
  var ah = this
  ah.Nav.setAttribute("ahHIDE", false)

  for (x=0; x < ah.NavC.length; x++) {
    if (ah.Pref("bars." + ah.NavC[x].id + ".always")) {
      ah.NavC[x].setAttribute("ahHIDE", false)
      continue
    }
    ah.NavC[x].setAttribute("ahHIDE", !ah.Pref("bars." + ah.NavC[x].id));
  }

  if (!ah.Pref("bars.tabBar") && !ah.Pref("bars.tabBar.always"))
    ah.tBar.setAttribute("ahHIDE", true);
  else
    ah.tBar.removeAttribute("ahHIDE");

  ah.Show = true

  if (aBool)
    autoHIDE.ResetMenu(true);
},

ResetMenu : function(aBool) {
  var ah = this
  ah.delta = getBrowser().mCurrentBrowser.boxObject.y
  ah.Nav.setAttribute("ahHIDE", true)

  for (x=0; x < ah.NavC.length; x++) {
    if (ah.Pref("bars." + ah.NavC[x].id + ".always")) {
      ah.Nav.setAttribute("ahHIDE", false)
      ah.NavC[x].setAttribute("ahHIDE", false)
      continue
    }
    ah.NavC[x].setAttribute("ahHIDE", true)
  }

  if (ah.Pref("bars.tabBar.always"))
    ah.tBar.removeAttribute("ahHIDE");
  else
    ah.tBar.setAttribute("ahHIDE", true);

  ah.delta = ah.delta-getBrowser().mCurrentBrowser.boxObject.y
  ah.Show = false

  if (aBool && ah.winUtil)
    ah.winUtil.goFull(true, ah.Pref("semiMode"), ah.Pref("multiFull"), ah.zombie);
},

InitHide : function(e) {
  var ah = this

  if (!fullScreen && !ah.zombie) {
    ah.NavC = ah.Nav.childNodes

    for (x=0;x < ah.NavC.length;x++) {
      if (ah.NavC[x].localName.toLowerCase() != "toolbar")
        continue;

      if (ah.Pref("keepButtons"))
        ah.NavC[x].removeAttribute("fullscreentoolbar");
      else
        ah.NavC[x].setAttribute("fullscreentoolbar", true);
    }

    ah.Win.setAttribute("persist", ah.Persist)

    if (ah.winUtil && (ah.Pref("zombieMode") || ah.winUtil.isShiftDown || ah.openZombie)) {
      ah.zombie = true
      ah.zombieMove = (ah.pref.getIntPref("zombieBorder") < 2 && ah.Pref("zombieMove")) ? true : false
      e.preventDefault()
      e.stopPropagation()
    }
    else
      ah.Win.removeAttribute("persist");

    ah.openZombie = false
    ah.senseArea = ah.pref.getIntPref("senseArea")
    ah.senseArea = ah.zombie ? ah.senseArea+3 : ah.senseArea+0
    ah.tBar = getBrowser().mStrip
    ah.sBar = document.getElementById("status-bar")
    ah.sBar.setAttribute("ahHIDE", !ah.Pref("bars.statBar.always"))
    ah.delay = ah.pref.getIntPref("delay")
    ah.hideDelay = ah.pref.getIntPref("hideDelay")
    ah.noFloat = ah.Pref("noFloat")
    getBrowser().addProgressListener(ah.ah4711, ah.CI.nsIWebProgress.NOTIFY_ALL)

    if (ah.winUtil)
      ah.obs.addObserver(ah.ahMouseObserver, "ahMouseMove", false);
    else
      addEventListener("mousemove", ah.ShowBars, true);

    addEventListener("popupshown", ah.ObservePopups, false)
    addEventListener("popuphidden", ah.ObservePopups, false)
    addEventListener("keypress", ah.ObserveInput, true)

    if (!ah.commandsChanged) {
      ah.ChangeCommand(["Browser:OpenLocation", "cmd_newNavigatorTab"],
                        "if (fullScreen || autoHIDE.zombie) autoHIDE.ObserveLocation('urlbar-container', this.id); ");

      ah.ChangeCommand(["Tools:Search"],
                        "if (fullScreen || autoHIDE.zombie) autoHIDE.ObserveLocation('search-container', this.id); ");

      ah.commandsChanged = true;
    }

    setTimeout('addEventListener("resize", autoHIDE.DisCap, true)', 1500)
    ah.BC.setAttribute("checked", true)
    ah.Popup = null
    return
  }

  if (ah.zombie) {
    e.preventDefault()
    e.stopPropagation()
    ah.zombie = false
  }

  ah.BC.setAttribute("checked", false)

  try {
    ah.obs.removeObserver(ah.ahMouseObserver, "ahMouseMove")
  }
  catch (e) {}

  if (ah.winUtil && !ah.noFloat && ah.Show)
    ah.MoveContent(false);

  getBrowser().removeProgressListener(ah.ah4711)
  removeEventListener("resize", ah.DisCap, true)
  removeEventListener("popupshown", ah.ObservePopups, false)
  removeEventListener("popuphidden", ah.ObservePopups, false)
  removeEventListener("mousemove", ah.ShowBars, true)
  removeEventListener("keypress", ah.ObserveInput, true)

  if (ah.winUtil)
    ah.winUtil.goFull(false, false, false, false);

  setTimeout(function () {
               while (document.getElementsByAttribute("ahHIDE", "*").length)
                 document.getElementsByAttribute("ahHIDE", "*")[0].removeAttribute("ahHIDE");

               ah.tBar.removeAttribute("ahHIDE");
               ah.Win.setAttribute("persist", ah.Persist);
             }, 0)
},

ChangeCommand : function(items, text) {
  for (x = 0; x < items.length; x++) {
    var item = document.getElementById(items[x])
    if (item)
      item.setAttribute("oncommand", text + item.getAttribute("oncommand"));
  }
},

ToShowOrNotToShow : function(ahNode) {
  while (ahNode != null) {
    if (ahNode.localName == "toolbar" &&
        (autoHIDE.Pref("bars."+ahNode.id+".always") ||
         autoHIDE.Pref("bars."+ahNode.id))) {
      if (!autoHIDE.Pref("bars."+ahNode.id+".always"))
        autoHIDE.HideToolbar();

      return true
      break
    }
    ahNode = ahNode.parentNode
  }
  return false
},

ObserveLocation : function(target, id) {
  if (autoHIDE.Show)
    return;

  var ahNode = null;

  if (document.getElementById(target))
    ahNode = document.getElementById(target);
  else
    return;

  autoHIDE.ToShowOrNotToShow(ahNode)
},

ObserveInput : function(e) {
  if ((autoHIDE.Show && e.keyCode == 13) || (!autoHIDE.Show && e.keyCode == 117))
    autoHIDE.HideToolbar();
},

ObservePopups : function(e) {
  var ahNode = e.originalTarget
  var ah = autoHIDE

  if (ahNode.nodeName != "tooltip") {
    if (e.type == "popupshowing" && !ah.Popup) {
      if (!ahNode.autoHIDEwasHere) {
        if (fullScreen || ah.zombie)
          ahNode.removeAttribute('menugenerated');

        ahNode.autoHIDEwasHere = true;
      }

      if ((fullScreen || ah.zombie) && !ah.Show && !ah.ToShowOrNotToShow(ahNode))
        e.preventDefault();
    }

    if (e.type == "popupshown" && !ah.Popup)
      ah.Popup = ahNode;

    if (e.type == "popuphidden" && ahNode == ah.Popup)
      ah.Popup = null;
  }
},

Pref : function(v) {
  try {
    return this.pref.getBoolPref(v)
  }
  catch (e) {
    return false
  }
},

DisCap : function(e) {
  e.preventDefault()
  e.stopPropagation()
}

}

function onFullScreen(e) {
  if (!fullScreen && !autoHIDE.zombie) {
    autoHIDE.InitHide(e)
    FullScreen.showXULChrome("toolbar", false)
    setTimeout("autoHIDE.SetMenu(true)", autoHIDE.pref.getIntPref("initialDelay"))
    return
  }

  if (fullScreen || autoHIDE.zombie) {
    autoHIDE.InitHide(e)
    FullScreen.showXULChrome("toolbar", true)
  }
}

addEventListener("load", function(){autoHIDE.GetCMDLine()}, false)